/*********************************************************************/
/*       fi_lib  --- A fast interval library (Version 1.1)           */
/*        (For copyright and info`s see file "fi_lib.h")             */
/*********************************************************************/

#include "ieee.h"
#include "global.h"

#ifdef FILIB_NAMESPACES
namespace filib 
{
#endif

double q_atnh(double x)
{
  double absx, res;
 

  if (Double::isNaN(x))
#ifdef FILIB_EXTENDED
    return Double::QUIET_NAN();
#else  
   res=q_abortnan(INV_ARG,&x,24);
#endif

 else
 {
 
  if ((x<=-1.0)||(1.0<=x))       
#ifdef FILIB_EXTENDED   
    return Double::QUIET_NAN();
#else  
      res=q_abortr1(INV_ARG,&x,24);
#endif

  if (x<0) absx=-x; else absx=x;
  if (absx>=q_at3i) res=0.5*q_log1((1+absx)/(1-absx));
  else              res=0.5*q_l1p1((2*absx)/(1-absx));
  if (x<0) res=-res;
  }

  return(res);

}

#ifdef FILIB_NAMESPACES
}
#endif
