/*********************************************************************/
/*       fi_lib  --- A fast interval library (Version 1.1)           */
/*        (For copyright and info`s see file "fi_lib.h")             */
/*********************************************************************/

#include "ieee.h"
#include "global.h"

#ifdef FILIB_NAMESPACES
namespace filib 
{
#endif

double q_sqrt(double x)
{
  double res;

  if (Double::isNaN(x))
#ifdef FILIB_EXTENDED
    return Double::QUIET_NAN();
#else  
    res=q_abortnan(INV_ARG,&x,0);
#endif

  else
    {
      if (x<0)
#ifdef FILIB_EXTENDED
	return Double::QUIET_NAN();
#else    
        res=q_abortr1(INV_ARG,&x,0);
#endif
      else
	res=sqrt(x);
    }
  
  return(res);
}

#ifdef FILIB_NAMESPACES
}



